package l10_concurrent;

import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;

public class Timeout extends Timer {
	public Timeout(int delay, final String msg, ScheduledExecutorService scheduler,
			ScheduledFuture<?> scheduledFuture) {
		super(true); // Daemon thread
		schedule(new TimerTask() {
			@Override
			public void run() {
				System.out.println(msg);
				scheduledFuture.cancel(false);
				scheduler.close();
			}
		}, delay);
	}
}

